#########################################
# Created 02/2020 Francesc Roura Adserias
#########################################

decathlon <-
	function(fcst.sdate = NULL,
                  hcst.inityear = NULL, 
	                hcst.endyear = NULL
	                ){ #region = TRUE/FALSE

      #-------------------------------------------------------------------
	    # Settings 
	    #-------------------------------------------------------------------
 
	    variable <- "tas" # for Decathlon we will only forecast temperature  
	    system.name <- "system5"
	    exp.dir <- "/esarchive/exp/ecmwf/system5c3s/" 
	    remap.method <- "con" 
	    ## TODO: change hardcoded ensemble
	    #ncores=16 #(?)
	    ncores = 1
	    split_factor=1 #(?)

	    #-------------------------------------------------------------------
	    # Init 
	    #-------------------------------------------------------------------
    
	    # frequencies of obs and exp for temperature (tas)

	    freq.exp <- "f6h"
	    freq.obs <- "f1h"

	    # Start dates and Lead times

	    fcst.month <- substr(fcst.sdate,5,6) 
	    fcst.year <- substr(fcst.sdate,1,4) 

	    fcst.sdate <- paste(fcst.year, fcst.month, sep = "")
	    hcst.sdates <- paste(strtoi(hcst.inityear):strtoi(hcst.endyear),
	                         fcst.month, sep = "")

	    obs.sdates <- hcst.sdates
    
	    if (system.name == "system5") {
	     hcst.nmember <- 25
	    } else {
	     stop("The system is not system5") 
	    }   
    
	    ltmin <- 2
	    fcst.freq <- "monthly_mean"
	    ltmax <- 4

	    #-------------------------------------------------------------------
	    # Timeseries load 
	    #-------------------------------------------------------------------
	    obs.path <- paste0(
	          "/esarchive/recon/ecmwf/era5/",fcst.freq,
	          "/tas_",
	          freq.obs,
	          "/tas_$file_date$.nc"
	        )

	    fcst.path <- paste0( exp.dir,fcst.freq, "/tas_", freq.exp,
	               "/tas_$sdate$01.nc"
	        )

	    hcst.path <- paste0(
	               exp.dir,fcst.freq,"/tas_",
	               freq.exp,
	               "/tas_$sdate$01.nc"
	        )
	    
	    paths <- list(obs = obs.path, fcst = fcst.path, hcst = hcst.path)
	    
	    return(paths)
	}

a <- decathlon(fcst.sdate = 202002,
                        hcst.inityear = 2015, 
                        hcst.endyear = 2010
                        )
